%{
  #include<stdio.h>

  typedef int YYSTYPE;
  void yyerror (const char *msg);
%}

%token T_num

%left '+' '-'
%left '*'
%left UMINUS

%%

program:
  expr  { printf("Result is %d\n", $1); }
;

expr:
  T_num          { $$ = $1; }
| expr '+' expr  { $$ = $1 + $3; }
| expr '*' expr  { $$ = $1 * $3; }
| expr '-' expr  { $$ = $1 - $3; }
| '-' expr  %prec UMINUS { $$ =  -$1; }
| '(' expr ')'   { $$ = $2; }
;

%%

void yyerror (const char *msg)
{
  printf("%s", msg);
}

int main ()
{
  return yyparse();
}
