open Format

type ast_program = ast_fun_def list

and ast_fun_def = Fundef of string * ast_param list * string list * ast_stmt list

and ast_param = Param of string
              | ParamByRef of string

and ast_stmt = Sprint of ast_expr
             | Slet of string * ast_expr
             | Sbegin of ast_stmt list
             | Sfor of string * ast_expr * ast_expr * ast_stmt
             | Swhile of ast_expr * ast_stmt
             | Sif of ast_expr * ast_stmt * ast_stmt option
             | Sreturn of ast_expr

and ast_expr = Enum of int
             | Eid of string
             | Ebool of bool
             | Eplus of ast_expr * ast_expr
             | Eminus of ast_expr * ast_expr
             | Ediv of ast_expr * ast_expr
             | Emult of ast_expr * ast_expr
             | Eand of ast_expr * ast_expr
             | Eor of ast_expr * ast_expr
             | Elt of ast_expr * ast_expr
             | Egt of ast_expr * ast_expr
             | Eeq of ast_expr * ast_expr
             | Eneq of ast_expr * ast_expr
             | Enot of ast_expr
             | Eunary of ast_expr
             | Eapp of string * ast_expr list

val ast_tree  : ast_program option ref
val print_ast : ast_program option -> unit

