open Scanner
open Format
open Ast
open Semantic

let main =
  let chan =
    (if Array.length Sys.argv > 1 then 
       open_in Sys.argv.(1)
    else 
       stdin) in
  try
    let lexbuf = Lexing.from_channel chan in
    (try
      Parser.program Scanner.lexer lexbuf;
      print_ast !ast_tree;
      check !ast_tree;
      infer !ast_tree;
      exit 0
    with 
    | Parsing.Parse_error ->
       printf "Syntax Error: Ln %d.\n" !num_lines;
       exit 1
    | Terminate reason ->
       printf "Semantic Error: %s ...\n" reason;
       exit 1)
  with End_of_file ->
    close_in chan

